extends PacketHandler

signal changed(ping: float)

const HISTORY_SIZE = 8

var count := 0
var history: Array[float] = []

func _init():
	history.resize(HISTORY_SIZE)

func handle_packet(data: PackedByteArray):
	var id := data[0]
	var ping := Time.get_unix_time_from_system() - history[id]
	emit.call_deferred(ping)

func emit(ping: float):
	changed.emit(ping)

func send_ping():
	var buffer := StreamPeerBuffer.new()
	buffer.put_u8(Packet.PING)
	buffer.put_u8(count)
	%Client.send(buffer.data_array)
	history[count] = Time.get_unix_time_from_system()
	count = (count + 1) % HISTORY_SIZE

