package game

import (
	"fmt"
	"math"
	"math/rand"
)

var (
	SpawnPoint = Vector3{584.98, 9.8, 394.68}
	accounts   = map[string]*Account{}
)

func init() {
	MakeTestAccounts()
}

// MakeTestAccounts creates accounts for stress testing.
func MakeTestAccounts() {
	for i := range 500 {
		angle := rand.Float64() * math.Pi * 2
		distance := rand.Float64() * 25.0

		accounts[fmt.Sprintf("user%d", i)] = &Account{
			ID:       fmt.Sprintf("id%d", i),
			Name:     fmt.Sprintf("user%d", i),
			Password: "password",
			Position: Vector3{SpawnPoint.X + float32(math.Cos(angle)*distance), SpawnPoint.Y, SpawnPoint.Z + float32(math.Sin(angle)*distance)},
		}
	}
}

// GetAccountByName retrieves the account with the given name.
func GetAccountByName(name string) *Account {
	return accounts[name]
}
