package game

import (
	"net"
)

// Jump broadcasts the jump action.
func (game *Game) Jump(data []byte, address *net.UDPAddr) error {
	player := game.players.ByAddress(address)

	if player == nil {
		return ErrUnknownAddress
	}

	game.BroadcastOthers(PlayerJump, []byte(player.ID), player)
	return nil
}
