package game

import (
	"errors"
	"net"
)

var (
	ErrInvalidPacketLength = errors.New("invalid packet length")
)

// UseSkill tries to use a player skill.
func (game *Game) UseSkill(data []byte, address *net.UDPAddr) error {
	player := game.players.ByAddress(address)

	if player == nil {
		return ErrUnknownAddress
	}

	if len(data) != 1 {
		return ErrInvalidPacketLength
	}

	slot := data[0]
	broadcast := []byte(player.ID)
	broadcast = append(broadcast, slot)

	game.BroadcastOthers(PlayerUseSkill, broadcast, player)
	return nil
}
